/* Grupa A:
Napišite program koji prvo učitava prirodni broj d, a nakon toga
čita cijele brojeve, sve dok razlika najvećeg i najmanjeg učitanog
broja ne bude strogo veća od d. Program treba ispisati najveći i
najmanji učitani broj.
Na primjer, za ulaz: 10 -1 2 0 -4 9, program staje i ispisuje 9 -4.

Rješenje:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int d, x, minx, maxx, prvi=1;

    printf("Ucitajte prirodan broj d:");
    scanf("%d", &d);

    while(1){
        printf("Ucitaj cijeli broj:");
        scanf("%d", &x);
        if (prvi==1){
            prvi=0;
            minx=maxx=x;
        }
        if(x>maxx)
            maxx=x;
        if(x<minx)
            minx=x;
        if(maxx-minx>d)
            break;
    }

    printf("Najveci i najmanji ucitani brojevi su: %d, %d\n", maxx, minx);

    return 0;
}

/*Rješenje bez breaka:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int d, x, minx, maxx, prvi=1;

    printf("Ucitajte prirodan broj d:");
    scanf("%d", &d);
    printf("Ucitaj cijeli broj:");
    scanf("%d", &x);
    minx=maxx=x;

    while(minx-maxx<=d){
        printf("Ucitaj cijeli broj:");
        scanf("%d", &x);
        if(x>maxx) maxx=x;
        if(x<minx) minx=x;
    }

    printf("Najveci i najmanji ucitani brojevi su: %d, %d\n", maxx, minx);

    return 0;
}


/* Grupa B:
Napišite program koji učitava cijele brojeve dok se ne učitaju uzastopno
dva broja iste parnosti. Tada se učitavanje prekida i treba ispisati sumu
učitanih brojeva bez zadnjeg broja.

Rješenje:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int x, y, suma=0, prvi=1;

    while(1){
        printf("Ucitaj cijeli broj:");
        scanf("%d", &x);
        if (prvi==1){
            prvi=0;
        }
        if(prvi==0 && (x-y)%2==0)
            break;
        y=x;
        suma+=y;
    }

    printf("Zbroj ucitanih brojeva je %d\n", suma);

    return 0;
}
/*Rješenje bez breaka:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int x, y, suma=0;
    printf("Ucitaj cijeli broj:");
    scanf("%d", &y); suma+=y;

    printf("Ucitaj cijeli broj:");
    scanf("%d", &x);

    while((x-y)%2){
        suma+=x;
        y=x;
        printf("Ucitaj cijeli broj:");
        scanf("%d", &x);
    }

    printf("Zbroj ucitanih brojeva je %d\n", suma);

    return 0;
}


/* Grupa C:
Napišite program koji učitava prirodni broj $n$, a zatim n prirodnih brojeva.
Program treba ispisati one brojeve koje imaju paran broj znamenki 3
u zapisu u bazi 4.

Rješenje:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int n, x, y, i, br;

    printf("Ucitajte prirodan broj n:");
    scanf("%d", &n);

    for(i=0; i<n; i++){
        printf("Ucitajte %d. prirodan broj:", i+1);
        scanf("%d", &x);
        br=0;
        y=x;
        while(y){
            if(y%4==3) br++;
            y/=4;
        }
        if(br%2==0)
            printf("%d\n", x);
    }

    return 0;
}



/* Grupa D:
Napišite program koji učitava prirodni broj n, a zatim među prvih n
prirodnih brojeva ispisuje one brojeve koji imaju samo nule i jedinice
u zapisu u bazi 5.

Rješenje:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int i, x, n;

    scanf("%d", &n);
    for (i=1; i<= n; i++)
    {
        x=i;
        while (x>0)
        {
            if (x%5>1)
                break;
            x/=5;
        }

        if (x==0)
            printf("%d\n", i);
    }

    return 0;
}


/*Rješenje bez breaka:
------------------------------------------------------------*/
#include <stdio.h>

int main(void)
{
    int i, x, n, zn;
    scanf("%d", &n);
    for (i=1; i<=n; i++)
    {
        x=i; zn=0;
        while (x>0 && zn==0)
        {
            if (x%5>1) zn=1;
            x /= 5;
        }

        if  (zn==0)
            printf("%d\n", i);
    }

    return 0;
}
